"""
Fonctions et constantes du TP1
"""

ALPHABET = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

def copie(texte):
    resultat = ""
    for lettre in texte:
        resultat = resultat + lettre
    return resultat

def decale(symbole, nb):
    if symbole in ALPHABET:
        i = ALPHABET.index(symbole)
        j = (i + nb) % 26
        return ALPHABET[j]
    else:
        return symbole

def chiffre(texte, nb):
    resultat = ""
    for symbole in texte:
        resultat += decale(symbole.upper(), nb)
    return resultat

def dechiffre(texte, nb):
    return chiffre(texte, -nb)

"""
Fonctions et constantes du TP2
"""

# Exercice 2
def force_brute(message):
    for i in range(...):
        print(i, dechiffre(..., ...))

# Exercice 5
def moindres_carres(l1, l2):
    total = 0
    for i in range(len(l1)):
        diff = (l1[i] - l2[i])**2
        total = total + diff
    return total

FREQUENCES = {'A': 0.0815, 'B': 0.0097, 'C': 0.0315, 'D': 0.0373, 'E': 0.1739,
              'F': 0.0112, 'G': 0.0097, 'H': 0.0085, 'I': 0.0731, 'J': 0.0045,
              'K': 0.0002, 'L': 0.0569, 'M': 0.0287, 'N': 0.0712, 'O': 0.0528,
              'P': 0.028, 'Q': 0.0121, 'R': 0.0664, 'S': 0.0814, 'T': 0.0722,
              'U': 0.0638, 'V': 0.0164, 'W': 0.0003, 'X': 0.0041, 'Y': 0.0028,
              'Z': 0.0015}

# Exercice 6
def calcul_frequences(message):
    freq = dict()
    for lettre in ALPHABET:
        freq[lettre] = 0
    compteur = ...
    for symbole in message:
        if symbole in ALPHABET:
            compteur = ...
            freq[symbole] = ...
    for lettre in freq:
        freq[lettre] = freq[lettre] / ...
    return freq

# Pour les exemples
un_message = "DECODE MOI SI TU PEUX."

"""
# Exemples :
>>> calcul_frequences(un_message)
{'A': 0.0, 'B': 0.0, 'C': 0.058823529411764705, 'D': 0.11764705882352941, 'E': 0.17647058823529413, 'F': 0.0, 'G': 0.0, 'H': 0.0, 'I': 0.11764705882352941, 'J': 0.0, 'K': 0.0, 'L': 0.0, 'M': 0.058823529411764705, 'N': 0.0, 'O': 0.11764705882352941, 'P': 0.058823529411764705, 'Q': 0.0, 'R': 0.0, 'S': 0.058823529411764705, 'T': 0.058823529411764705, 'U': 0.11764705882352941, 'V': 0.0, 'W': 0.0, 'X': 0.058823529411764705, 'Y': 0.0, 'Z': 0.0}
>>> calcul_frequences(chiffre(un_message, 1))
{'A': 0.0, 'B': 0.0, 'C': 0.0, 'D': 0.058823529411764705, 'E': 0.11764705882352941, 'F': 0.17647058823529413, 'G': 0.0, 'H': 0.0, 'I': 0.0, 'J': 0.11764705882352941, 'K': 0.0, 'L': 0.0, 'M': 0.0, 'N': 0.058823529411764705, 'O': 0.0, 'P': 0.11764705882352941, 'Q': 0.058823529411764705, 'R': 0.0, 'S': 0.0, 'T': 0.058823529411764705, 'U': 0.058823529411764705, 'V': 0.11764705882352941, 'W': 0.0, 'X': 0.0, 'Y': 0.058823529411764705, 'Z': 0.0}
# Les fréquences des lettres sont décalées de 1 (la fréquence de C passe à D).

>>> calcul_frequences(chiffre(un_message, 2))
{'A': 0.0, 'B': 0.0, 'C': 0.0, 'D': 0.0, 'E': 0.058823529411764705, 'F': 0.11764705882352941, 'G': 0.17647058823529413, 'H': 0.0, 'I': 0.0, 'J': 0.0, 'K': 0.11764705882352941, 'L': 0.0, 'M': 0.0, 'N': 0.0, 'O': 0.058823529411764705, 'P': 0.0, 'Q': 0.11764705882352941, 'R': 0.058823529411764705, 'S': 0.0, 'T': 0.0, 'U': 0.058823529411764705, 'V': 0.058823529411764705, 'W': 0.11764705882352941, 'X': 0.0, 'Y': 0.0, 'Z': 0.058823529411764705}
# Les fréquences des lettres sont décalées de 2 (la fréquence de C passe à E).
"""


# Exercice 7
def moindres_carres_freq(frequences):
    total = ...
    for lettre in frequences:
        total = ...
    return total

"""
# Exemples :
>>> moindres_carres_freq(calcul_frequences(un_message))
0.04202869892733564
>>> moindres_carres_freq(calcul_frequences(chiffre(un_message, 1)))
0.09885222833910037
>>> moindres_carres_freq(calcul_frequences(chiffre(un_message, 8)))
0.13184046363321802
>>> moindres_carres_freq(calcul_frequences(chiffre(un_message, 20)))
0.12548752245674744
>>> moindres_carres_freq(calcul_frequences(chiffre(un_message, 25)))
0.09795811069204154

# On voit que le score le plus faible est obtenu avec le message en clair.
"""


# Exercice 8
def cryptanalyse(message):
    meilleur_total = 26
    meilleur_decal = 0
    for i in range(...):
        mess = dechiffre(..., ...)
        freq = calcul_frequences(...)
        total = moindres_carres_freq(...)
        if ...:
            meilleur_total = ...
            meilleur_decal = ...
    return meilleur_decal

"""
# Exemples :
>>> cryptanalyse(un_message)
0
>>> cryptanalyse(chiffre(un_message, 4))
4
>>> cryptanalyse(chiffre(un_message, 17))
17

# A chaque fois, on trouve le bon décalage.
"""

# Exercice 9
def decodage_chapitre():
    with open("chapitre_chiffre.txt", "r", encoding='utf8') as f:
        bloc = ""
        liste = []
        for ligne in f:
            bloc = bloc + ligne
            if ligne == '\n':
                dec = cryptanalyse(bloc)
                print(dechiffre(bloc, dec))
                bloc = ""
        return liste

# Bonus : extrait de La Disparition
disparition = """Il lui suffit alors d'y approfondir son 
agonisant frangin pour voir s'accomplir son forfait qui, 
par surcroît, profita au pays, puisqu'un mois plus tard, 
tout un chacun s'accordait pour nantir l'intrigant flux 
qui sourdait du puits d'un fort pouvoir curatif, surtout 
anticatarrhal, mais s'appliquant aussi à l'albugo, à 
l'anchilops, aux bubons, aux calculs, aux chalazions, au 
trismus, au pityriasis, au mal blanc, au prurigo, 
au mal caduc, au glossanthrax. 
""".upper()