import random # pour faire des tirages aléatoires

def conversion(nb):
    binaire = ""
    while nb >= 2:
        reste = nb % 2
        binaire = str(reste) + binaire
        nb = nb // 2
    binaire = str(nb) + binaire
    return binaire

def deconversion(binaire):
    nb = 0
    for b in binaire:
        nb = nb * 2
        if b == "1":
            nb = nb + 1
    return nb

def creer_grilles(n):
    grilles = [] # la liste des grilles
    for i in range(n):
        grilles.append([]) # on rajoute une liste vide
    return grilles

def placer_dans_grilles(nb, grilles):
    copie = nb
    n = len(grilles) # n est le nombre de sous grilles
    for i in range(n):
        grille = grilles[i] # la sous grille d'indice i
        if copie % 2 == 1: # dans quel cas il faut rajouter quelque chose ?
            grille.append(nb) # qu'est-ce qu'on rajoute à grille ?
        copie = copie // 2 # et ensuite, on fait quoi à copie ?

def construire_grilles(n):
    grilles = creer_grilles(n)
    for nb in range(1, 2**n): # tous les nombres de 1 à (2^n)-1 inclus
        placer_dans_grilles(nb, grilles)
    return grilles

def demander_utilisateur(grille):
    print("Est-ce que le nombre est dans cette grille :")
    print(grille)  # on affiche la grille
    reponse = "reponse pas bonne"
    while reponse != "O" and reponse != "N": # toujours pas de bonne réponse
        reponse = input("O/N ? ")
        reponse = upper(reponse) # on met en majuscule
    if reponse == "O": # pour quelle valeur est-ce qu'on renvoie True ?
        return True
    else:
        return False # Sinon quoi ?

def mentaliste(n):
    grilles = construire_grilles(n) # on fabrique les grilles
    print("Pense à un nombre entre 1 et", 2**n-1)
    nb = 0 # quelle valeur initiale ?
    for i in range(n):
        grille = grilles[i]
        reponse = demander_utilisateur(grille) # on demande à l'utilisateur
        if reponse: # dans quel cas est-ce qu'on fait quelque chose ?
            nb = grille[0] # on rajoute le premier élément de la grille
    print("Le nombre auquel tu penses est", nb)

def mentaliste_inverse(n):
    print("Je pense à un nombre entre 1 et", 2**n-1)
    nb_secret = random.randint(1, 2**n-1) # on tire au hasard une valeur
    grilles = construire_grilles(n)
    for i in range(n):
        if nb_secret in grilles[i]:
            print("Il est dans", grilles[i])
        else:
            print("Il n'est pas dans", grilles[i])
    reponse = int(input("Devine le nombre auquel je pense : "))
    if reponse == nb_secret:
        print("Tu es trop fort !")
    else:
        print("Tu as tout faux, c'était", nb_secret)