import random # Pour les tirages aleatoires
import sys # Pour quitter proprement
import pygame # Le module Pygame
import pygame.freetype # Pour afficher du texte
from initiation import *
pygame.init() # initialisation de Pygame

# Taille de la fenetre
largeur = 1000
hauteur = 700
screen = pygame.display.set_mode((largeur, hauteur))
pygame.display.set_caption("Le mentaliste")

NB_BITS = 6

# Definition des couleurs
black = (0, 0, 0)
white = (255, 255, 255)
gris = (100, 100, 200)
jaune = (230, 230, 0)
# Pour le texte. Decommenter la 1e ligne et une des 2 suivantes
pygame.freetype.init()
police = pygame.freetype.SysFont(None, 20)

# Pour controler le nombre d'images par seconde
clock = pygame.time.Clock()

def afficher_grille(pos, grille, n, l, h, meilleur_i, nb_par_ligne, nb_par_col, esph, espv, taille, actif=False, nb_secret=-1, surligner=False):
    x, y = pos
    if actif:
        couleur = white
    else:
        couleur = gris
    pygame.draw.rect(screen, couleur, (x, y, l, h), 3)
    for k in range(len(grille)):
        i = k%nb_par_ligne
        j = k//nb_par_ligne
        if grille[k] == nb_secret and surligner:
            texte, rect = police.render(str(grille[k]), jaune, size = taille)
        else:
            texte, rect = police.render(str(grille[k]), couleur, size = taille)
        rect.center = (x+(i+.5)*esph, y+(j+.5)*espv)
        screen.blit(texte, rect)

def afficher_bouton(pos, l, h):
    x, y = pos
    pygame.draw.rect(screen, white, (x, y, l, h), 3)
    texte, rect = police.render("Révéler le nombre secret", white, size = 20)
    rect.center = (x+.5*l, y+.5*h)
    screen.blit(texte, rect)

def calculer_espaces(l, h, n):
    nb_par_ligne = 2 ** (n-1)
    nb_par_col = 1
    meilleur_ratio = 1000
    meilleur_i = 0
    for i in range(n-1):
        esph = l / nb_par_ligne
        espv = h / nb_par_col
        ratio = max(esph, espv) / min(esph, espv)
        if ratio < meilleur_ratio:
            meilleur_ratio = ratio
            meilleur_i = i
        nb_par_ligne = nb_par_ligne // 2
        nb_par_col = nb_par_col * 2
    nb_par_ligne = 2**(n-1-meilleur_i)
    nb_par_col = 2**(meilleur_i)
    esph = l / (nb_par_ligne)
    espv = h / (nb_par_col)
    return meilleur_i, nb_par_ligne, nb_par_col, esph, espv

def calculer_taille(grille, esph, espv):
    taille = 40
    texte, rect = police.render(str(grille[-1]), white, size = taille)
    while rect.width > 0.8*esph or rect.height > 0.9*espv:
        taille = taille - 1
        texte, rect = police.render(str(grille[-1]), white, size = taille)
    return taille

grilles = construire_grilles(NB_BITS)
l = (largeur - 20)
h = (hauteur - 50) // NB_BITS - 10
meilleur_i, nb_par_ligne, nb_par_col, esph, espv = calculer_espaces(l, h, NB_BITS)
taille = calculer_taille(grilles[-1], esph, espv)

actifs = [False] * NB_BITS
nb_secret = -1
# Boucle principale
reveler = False
while 1:
    # Initialisation des variables en debut de boucle
    screen.fill(black)
    x,y=pygame.mouse.get_pos() # coordonnees du pointeur de la souris
    clic = False
    
    # Gestion des evenements
    for event in pygame.event.get():
        if event.type == pygame.QUIT: sys.exit() # Pour quitter
        elif event.type == pygame.MOUSEBUTTONDOWN:
            clic = True
            nb_secret = -1
            reveler = False

    # On regarde si on a cliqué sur une grille ou le bouton
    if clic and 0 <= x-10 < l:
        nb_secret = 0
        for i in range(NB_BITS):
            if 0 <= y-(10+(h+10)*i) < h:
                actifs[i] = not actifs[i]
            if actifs[i]:
                nb_secret = nb_secret + grilles[i][0]
        if 0 <= y-(hauteur-50) < 40:
            reveler = True
            
    afficher_bouton((10, hauteur-50), l, 40)
    for i in range(NB_BITS):
        afficher_grille((10, 10+(h+10)*i), grilles[i], NB_BITS, l, h, meilleur_i, nb_par_ligne, nb_par_col, esph, espv, taille, actifs[i], nb_secret, reveler)
    # On affiche le resultat final a l'ecran
    pygame.display.flip()
    # On attend le temps necessaire pour avoir un FPS constant
    clock.tick(30)
